clc
clear all;
close all;
disp('State Space Analysis');
%Given transfer function
num=[1 0];
den=[1 2 2.5 0.5];
G=tf(num,den)
%Construct state varible model
sys=ss(G);
[A,b,c,d]=ssdata(sys)
%Discretization
T=0.1;
sysd=c2d(sys,T);
[F,g,c,d]=ssdata(sysd)
%Simulation
t=[0:0.1:20]';
x0=[1 0 2]';
%Input for 0<t<2
u(1:20)=2*ones(20,1);
%Input for t>2
u(21:201)=0.5*ones(181,1);
[y,t,X]=lsim(sys,u,t,x0);
[y1,t,X1]=lsim(sysd,u,t,x0);
figure(1)
plot(t,X(:,1),t,X1(:,1),'o');grid;
legend('x_1');
figure(2)
plot(t,X(:,2),t,X1(:,2),'o');grid;
legend('x_2');
figure(3)
plot(t,X(:,3),t,X1(:,3),'o');grid;
legend('x_3');

