clc
clear all
close all
disp('Refer Example 7.2');
% Linear Quadratic Regulator for Inverted Pendulum Plant Model
A=[0 1 0 0 ; 16.3106 0 0 0 ; 0 0 0 1 ; -1.0637 0 0 0];
b=[0 ; -1.4458 ; 0 ; 0.9639];
c=[1 0 0 0];
d=[0];
sys=ss(A,b,c,d);
U=ctrb(A,b);
ControllablePoles=rank(U)
% Performance Index
Q=[150 0 0 0 ; 0 1 0 0 ; 0 0 40 0 ; 0 0 0 1];
R=1;
% State Feedback
[k P E]=lqr(A,b,Q,R);
PolesCL=E
GainMatrix=k
sysCL=ss(A-b*k,[0 0 0 0]',c,d);
% Simulation
x0=[0.1 0 0 0];
t=[0:0.1:20];
[y,t,x]=initial(sysCL,x0,t);
figure(1)
subplot(2,2,1);plot(t,x(:,1));grid;legend('x_1');
title('                             Response of linear model with controller');
subplot(2,2,2);plot(t,x(:,2));grid;legend('x_2');
subplot(2,2,3);plot(t,x(:,3));grid;legend('x_3');
subplot(2,2,4);plot(t,x(:,4));grid;legend('x_4');