clc
clear all
close all
disp('Refer Example 7.2');
% Digital Servo for Inverted Pendulum Plant Model
A=[0 1 0 0 ; 16.3106 0 0 0 ; 0 0 0 1 ; -1.0637 0 0 0];
b=[0 ; -1.4458 ; 0 ; 0.9639];
c=[1 0 0 0];
d=[0];
sys=ss(A,b,c,d);
T=0.1;
sysd=c2d(sys,T);
[F,g,c,d]=ssdata(sysd);
% Plant Model with integral state
% Refer Eqn.(7.109)
FI=[F(1,:),0; F(2,:),0; F(3,:),0; F(4,:),0; c*F 1];
gI=[g(1); g(2); g(3); g(4); c*g];
cI=[c,0];
U=ctrb(FI,gI);
rankU=rank(U)
% Performance Index
Q=[10 0 0 0 0 ; 0 1 0 0 0 ; 0 0 100 0 0 ; 0 0 0 1 0 ; 0 0 0 0 1];
R=1;
% State Feedback with Integral Control
K=dlqr(FI,gI,Q,R);
Kp=[K(1) ; K(2) ; K(3); K(4)]
Ki=K(5)
% Simulation(step response)
% Refer Eqns.(7.108)&(7.110)
FI_CL=FI-gI*K;
sysCL=ss(FI_CL,[0 0 0 0 -1]',cI,d,'Ts',T);
t=[0:0.1:20];
[y,t,X]=step(sysCL,t);
plot(t,y);grid;