clc
clear all;
close all;
disp('Refer Example 4.4');
%Direct Digital Design (lead compensation)
%Uncompensated system
G=tf(50,[1 5 0]);
%Discretization
Gz=c2d(G,0.1);
%Design in w-domain
Gw=d2c(Gz,'tustin');
figure(1);
margin(Gw);
%Read compensated phase margin from figure 1.
%PhiM=specified phase margin-uncompensated
%phase margin+epsilon=35
PhiM=input('Enter required phase lead: ')
alpha=(1-sin(PhiM*pi/180))/(1+sin(PhiM*pi/180));
w=logspace(0,2,100);
[mag,ph]=bode(Gw,w);
magdB=20*log10(mag);
magdB=reshape(magdB,100,1);
wm=interp1(magdB,w,-20*log10(1/sqrt(alpha)));
tau=1/(wm*sqrt(alpha));
Dw=tf([tau,1],[alpha*tau,1])
%Digital controller
D=c2d(Dw,0.1,'tustin');
Dz=zpk(D)
figure(2);
%Read compensated phase margin from figure 2
margin(Dw*Gw);
%Bandwidth (uncompensated & compensated)
w=[5:0.1:25];
[mag,ph,w]=bode(feedback(Gw,1));
magbB=20*log10(mag);
wb=interp1q(-magdB,w,3)
[mag1,ph1,w]=bode(feedback(Dw*Gw,1));
mag1dB=20*log10(mag1);
wb1=interp1q(-mag1dB,w,3)
%Analysis on Nichols chart
figure(3)
Gwc=Dw*Gw;
nichols(Gw,Gwc);ngrid;
%Step-response analysis using GUI
Mz=feedback(D*Gz,1);
figure(4)
step(Mz);

