clc
close all;
clear all;
disp('Refer Example 4.7');
%Digital Controller Design on Rootlocus plots
%Plant model
G=tf(1,[1 2 0]);
T=0.2;
Gz=c2d(G,T);Gz1=zpk(Gz);
zeta=0.5;wn=4;
theta=wn*T*sqrt(1-zeta^2);
figure(1)
%Uncompensated root loci
rlocus(Gz);
%Take near-zero value for wn in zgrid function
%if you are not using wn locus in your design procedure.
zgrid(0.5,.01);
axis equal;
hold on
%Locate desired dominant roots
polar(theta*[1 1],[0 1],'k');
%Gain adjustment does not satisfy specs.
%Lead compensator zero to cancel open-loop
%pole at z=0.67. Take pole at z=alpha.
alpha=input('Enter trail value of alpha: ');
Dz=tf([1 -0.67],[1 -alpha],T);
figure(2)
rlocus(Dz*Gz);
zgrid(zeta,0.01);
axis equal;
hold on
polar(theta*[1 1],[0 1],'k');
[KK,polesCL]=rlocfind(Dz*Gz)
%Place the crosshair cursor at desired root and click
Gvz=tf([1 -1],1,T)*Dz*KK*Gz/T;
Kvz=dcgain(Gvz)
%Perform simulation study on compensated system
%using GUI.
Mz=feedback(KK*Dz*Gz,1);
figure(3)
step(Mz);
